C     THIS FILE CONTAINS THE FOLLOWING SUBROUTINES
C     NECESSARY FOR LZW-COMPRESSION:
C
C     SUBROUTINE STR_INIT(CHARSTRING,SINGLECHAR)        
C     CHARACTER*(*) CHARSTRING
C     CHARACTER*1   SINGLECHAR
C
C     INTEGER*4 FUNCTION STR_HASH(CHARSTRING,MODULUSVAL)        
C     CHARACTER*(*) CHARSTRING
C     INTEGER*4 MODULUSVAL
C
C     THESE SUBROUTINES USE SPECIAL FUNCTIONS WHICH ARE
C     NOT STANDARD FORTRAN. THEY ARE AVAILABLE UNDER
C     SALFORD FORTRAN 77. 
C
C     TRANSLATION FROM THE VMS-VERSION OF ARNE VAJHOJ
C     GRAZ, MAI 1995                  ROBERT HOSCHEK
C                (e-mail: hoschek@igte.tu-graz.ac.at)
      
      SUBROUTINE STR_INIT(CHARSTRING,SINGLECHAR)        
        
      CHARACTER*(*) CHARSTRING
      CHARACTER*1 SINGLECHAR
        
      INTEGER*4 I,L      
      
      L=LEN(CHARSTRING)
      DO I=1,L
        CHARSTRING(I:I)=SINGLECHAR
      END DO
      RETURN
      END
      
      INTEGER*4 FUNCTION STR_HASH(CHARSTRING,MODULUSVAL)        
        
      CHARACTER*(*) CHARSTRING
      INTEGER*4 MODULUSVAL,RESULT,L,I,VAL,ADDR
      INTEGER*1 VAL1
      INTEGER*2 VAL2

      RESULT=0  
      L=LEN(CHARSTRING)
      DO I=1,L,2
        ADDR=LOC(CHARSTRING(I:I))
C       LOC returns a 4-byte address-pointer of the argument     
        IF(I.EQ.L) THEN
          VAL1=CORE1(ADDR)
C         CORE1 returns a 1-byte value from memory specified 
C         by the argument as an address-pointer
          VAL=INT(VAL1)
        ELSE
          VAL2=CORE2(ADDR)
C         CORE2 returns a 2-byte value from memory specified 
C         by the argument as an address-pointer
          VAL=INT(VAL2)
        ENDIF
        RESULT=RESULT+VAL
      END DO
      STR_HASH=MOD(RESULT,MODULUSVAL)
C     MOD ... Modulo function
      RETURN
      END

